#!/usr/bin/perl -w
# Generate sigs
# There's a thousand and one ways this could be optimized.  I ain't gonna
# do it, because I'm too lazy and I'm more interested in doing this,
# right now, than in doing it right.  It doesn't have very heavy
# error-handling either.  Cope.
# $Fuller: myprograms/sigman/siggen.pl,v 1.4 2002/07/11 07:13:14 fullermd Exp $

use strict;

# Some definitions
my $STATE_NONE=0;
my $STATE_NAME=1;
my $STATE_QUOTE=2;

# First, suck up the file
my @cont;
open QUOTES, "quotes";
while(<QUOTES>)
{
	if(!(/^##/))
	{ chomp; push @cont, $_; }
}
close QUOTES;

my %quotes;
my $qname;
my $state = $STATE_NONE;
# Sort it out
foreach (@cont)
{
	# If NONE, we're at the beginning of the file
	if($state==$STATE_NONE)
	{	$state=$STATE_NAME; next;  }

	# If we're at NAME, there's a name here
	if($state==$STATE_NAME)
	{
		$qname = $_;
		$quotes{$qname}="";
		$state = $STATE_QUOTE;
		next;
	}

	# If QUOTE, start storing quote
	if($state==$STATE_QUOTE)
	{
		# Divider
		if(/^%%$/)
		{  next;  }

		# End
		if(/^&&$/)
		{  $state=$STATE_NAME; $qname=""; next;  }

		# Quote (line) to store
		# An array would be nice here, but alas...
		if(length($quotes{$qname})>1)
		{  $quotes{$qname} .= "\n";  }
		$quotes{$qname} .= $_;
		next;
	}
}

# Test point
#foreach my $key (keys %quotes)
#{  print "******\nName: $key\n%%%\nQuote:\n$quotes{$key}\n";  }

# Suck in base part
my @base;
open BASE, "sigbase";
while(<BASE>)
{
	chomp;
	push @base, $_;
}
close BASE;

# Start outputing
system("rm -rf out");
mkdir "out";

foreach my $key (keys %quotes)
{
	open SIG, ">out/$key.sig";
	print SIG "\n-- \n";
	print SIG map { "$_\n" } @base;
	# If quote is more than 1 line, put a blank space
	if( $quotes{$key} =~ /\n/ )
	{  print SIG "\n";  }
	print SIG "$quotes{$key}";
	# This makes 'cat'ing a bit cleaner, though it adds an extra line.
	# Tradeoff.
	print SIG "\n";
	close SIG;
}

# And copy over the 'fixed' ones
system("cp `echo fixed/* | sed \"s/fixed\\\/CVS//\"` out/");
